=== debian/changelog ===
s390-tools (2.29.0-0ubuntu2) mantic; urgency=medium

  * d/rules: Split the vendoring process into several discrete targets to be
    able to update the vendored code without having to update the tarball.
    This can be useful for security updates.
  * d/update-crate.sh: introduce a script to help updating a single crate
  * d/rules: don't overwrite the vendor tarball if it already exists. This
    should prevent some borked uploads.
  * d/README.source: Document the procedures for single-crate update as well
    as wholesale refresh of the vendor tarball.

 -- Simon Chopin <schopin@ubuntu.com>  Wed, 20 Sep 2023 11:21:48 +0200

s390-tools (2.29.0-0ubuntu1) mantic; urgency=medium

  [ Frank Heimes ]
   * New upstream release, requested in LP: #2030316
     - Remove d/p/lp-2025578-Recursive-Makefiles-avoid-race-condition.patch
       since it's part of latest upstream version.
     - Adds KVM: Support AP Bindings in SE Header LP: #1983221
     - Adds Userspace Tool for IBK Request Generation and Insertion LP: #2003676
     - d/control: bumped Standards-Version version to 4.6.2.
     - d/s/lintian-overrides: Suppress lintian unknown-field(s)
       Build-Indep-Architecture and Vendored-Sources-Rust messages.
   * Update d/copyright and add. entries for the vendored crates.
   * Add pvsecret files to d/s390-tools.install.

  [ Simon Chopin ]
  * d/{rules,control}: Initial Rust packaging, including vendored sources.
  * Add d/p/rust_paths.patch to adapt upstream Rust Makefile for Debian's
    Rust tooling.
  * Add d/p/vendor-remove-unused-deps.patch to remove non relevant dependencies
    on some vendored crates.

 -- Frank Heimes <frank.heimes@canonical.com>  Sun, 06 Aug 2023 14:48:33 +0200
