=== debian/changelog ===
s390-tools (2.30.0-0ubuntu1) noble; urgency=medium

  * Remove some unused test directories from vendored dependencies to
    reduce the overall size of the vendor tarball

  [ Frank Heimes ]
  * New upstream release, requested in LP: #2045953
    - Remove d/p/lp-2028936-zkey-Support-EP11-AES-keys-with-prepended-.patch
      since it's now incl. in upstream 2.30.0.
    - Adjust d/p/rust_path.patch to align with changes in Makefile.
    - Adjust d/update-crate.sh and d/rules and point to the new workspace.
    - Due to the updated mockito crate 1.0, the entire tokio runtime is pulled
      in (needed for testing), which increases the vendored crate tar ball size
      to 5.5MB.
    - Update and expand d/vendor-remove-unused-deps.patch due to context changes
      in Cargo.toml files and because additional crates were added.
    - Update XS-Vendored-Sources-Rust field in d/control.
    - Adjust d/rules to not remove $(CARGO_VENDOR_DIR)/vcpkg,
      to fix a build issue.

 -- Simon Chopin <schopin@ubuntu.com>  Tue, 16 Jan 2024 11:58:42 +0100

s390-tools (2.29.0-0ubuntu3) noble; urgency=medium

  * Change zkey to generate EP11 keys using a new format (PKEY_TYPE_EP11_AES),
    that allows to keep support for existing key blobs by adding d/p/
    lp-2028936-zkey-Support-EP11-AES-keys-with-prepended-header-to-.patch
    (LP: #2028936)

 -- Frank Heimes <frank.heimes@canonical.com>  Tue, 28 Nov 2023 12:00:58 +0100
