=== debian/control ===
--- 
+++ 
@@ -27,7 +27,7 @@
 Standards-Version: 4.6.2
 Homepage: https://github.com/ibm-s390-linux/s390-tools
 XS-Build-Indep-Architecture: s390x
-XS-Vendored-Sources-Rust: anstream@0.3.2, anstyle-parse@0.2.0, anstyle-query@1.0.0, anstyle-wincon@1.0.1, anstyle@1.0.0, anyhow@1.0.71, autocfg@1.1.0, bitflags@1.3.2, byteorder@1.4.3, cc@1.0.79, cfg-if@1.0.0, clap@4.3.4, clap_builder@4.3.4, clap_derive@4.3.2, clap_lex@0.5.0, colorchoice@1.0.0, curl-sys@0.4.63+curl-8.1.2, curl@0.4.44, errno-dragonfly@0.1.2, errno@0.3.1, foreign-types-shared@0.1.1, foreign-types@0.3.2, hashbrown@0.12.3, heck@0.4.1, hermit-abi@0.3.1, indexmap@1.9.3, io-lifetimes@1.0.11, is-terminal@0.4.7, itoa@1.0.6, libc@0.2.146, libz-sys@1.1.9, linux-raw-sys@0.3.8, log@0.4.19, once_cell@1.18.0, openssl-macros@0.1.1, openssl-probe@0.1.5, openssl-sys@0.9.88, openssl@0.10.54, pkg-config@0.3.27, proc-macro2@1.0.60, quote@1.0.28, rustix@0.37.20, ryu@1.0.13, schannel@0.1.21, serde@1.0.164, serde_derive@1.0.164, serde_yaml@0.9.21, socket2@0.4.9, strsim@0.10.0, syn@1.0.109, syn@2.0.18, terminal_size@0.2.6, thiserror-impl@1.0.40, thiserror@1.0.40, unicode-ident@1.0.9, unsafe-libyaml@0.2.8, utf8parse@0.2.1, zerocopy-derive@0.3.2, zerocopy@0.6.1
+XS-Vendored-Sources-Rust: addr2line@0.21.0, adler@1.0.2, aho-corasick@1.1.2, anstream@0.3.2, anstyle-parse@0.2.0, anstyle-query@1.0.0, anstyle-wincon@1.0.1, anstyle@1.0.0, anyhow@1.0.71, assert-json-diff@2.0.2, autocfg@1.1.0, backtrace@0.3.69, bitflags@1.3.2, bitflags@2.4.1, byteorder@1.4.3, bytes@1.5.0, cc@1.0.79, cfg-if@1.0.0, clap@4.3.4, clap_builder@4.3.4, clap_derive@4.3.2, clap_lex@0.5.0, colorchoice@1.0.0, curl-sys@0.4.68+curl-8.4.0, curl@0.4.44, equivalent@1.0.1, errno-dragonfly@0.1.2, errno@0.3.1, fnv@1.0.7, foreign-types-shared@0.1.1, foreign-types@0.3.2, form_urlencoded@1.2.0, futures-channel@0.3.29, futures-core@0.3.29, futures-executor@0.3.29, futures-io@0.3.29, futures-macro@0.3.29, futures-sink@0.3.29, futures-task@0.3.29, futures-util@0.3.29, futures@0.3.29, getrandom@0.2.10, gimli@0.28.1, h2@0.3.22, hashbrown@0.12.3, hashbrown@0.14.3, heck@0.4.1, hermit-abi@0.3.1, http-body@0.4.5, http@0.2.11, httparse@1.8.0, httpdate@1.0.3, hyper@0.14.27, indexmap@1.9.3, indexmap@2.1.0, io-lifetimes@1.0.11, is-terminal@0.4.7, itoa@1.0.6, lazy_static@1.4.0, libc@0.2.146, libz-sys@1.1.9, linux-raw-sys@0.3.8, lock_api@0.4.11, log@0.4.19, memchr@2.6.4, miniz_oxide@0.7.1, mio@0.8.8, mockito@1.2.0, num_cpus@1.16.0, object@0.32.1, once_cell@1.18.0, openssl-macros@0.1.1, openssl-probe@0.1.5, openssl-sys@0.9.96, openssl@0.10.60, parking_lot@0.12.1, parking_lot_core@0.9.9, percent-encoding@2.3.0, pin-project-lite@0.2.13, pin-utils@0.1.0, pkg-config@0.3.27, ppv-lite86@0.2.17, proc-macro2@1.0.60, quote@1.0.28, rand@0.8.5, rand_chacha@0.3.1, rand_core@0.6.4, redox_syscall@0.4.1, regex-automata@0.4.3, regex-syntax@0.8.2, regex@1.10.2, rustc-demangle@0.1.23, rustix@0.37.27, ryu@1.0.13, schannel@0.1.21, scopeguard@1.2.0, serde@1.0.164, serde_derive@1.0.164, serde_json@1.0.99, serde_test@1.0.176, serde_urlencoded@0.7.1, serde_yaml@0.9.21, signal-hook-registry@1.4.1, similar@2.3.0, slab@0.4.9, smallvec@1.11.2, socket2@0.4.9, socket2@0.5.4, strsim@0.10.0, syn@1.0.109, syn@2.0.18, terminal_size@0.2.6, thiserror-impl@1.0.40, thiserror@1.0.40, tokio-macros@2.1.0, tokio-util@0.7.10, tokio@1.33.0, tower-service@0.3.2, tracing-core@0.1.32, tracing@0.1.40, try-lock@0.2.4, unicode-ident@1.0.9, unsafe-libyaml@0.2.8, utf8parse@0.2.1, vcpkg@0.2.15, want@0.3.1, wasi@0.11.0+wasi-snapshot-preview1, zerocopy-derive@0.3.2, zerocopy@0.6.1
 
 Package: s390-tools
 Architecture: s390 s390x amd64 ppc64el arm64
